
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Raft对比ZAB协议 / iVAN</title>

    <meta name="description" content="Raft对比ZAB协议 系列文章 Raft算法赏析 ZooKeeper的一致性算法赏析 Raft对比ZAB协议 0 一致性问题 本篇文章想总结下Raft和ZAB在处理一些一致性问题上的做法,详见之前对这2个算法的描述 Raft算法赏析 ZooKeeper的一致性算法赏析 上述分别是针对如下算法实现的讨论: Raft的实现copycat,由于Raft算法本身已经介绍的相当清晰,copycat基本上和Raft算法保持一致 ZAB的实现ZooKeeper,由于ZooKeeper里面的很多实现细节并没有在ZAB里体现(ZAB里">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Raft对比ZAB协议</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>系列文章</p>
<ul>
<li><a href="https://my.oschina.net/pingpangkuangmo/blog/776714" rel="external nofollow noreferrer">Raft算法赏析</a></li>
<li><a href="https://my.oschina.net/pingpangkuangmo/blog/778927" rel="external nofollow noreferrer">ZooKeeper的一致性算法赏析</a></li>
<li><a href="https://my.oschina.net/pingpangkuangmo/blog/782702" rel="external nofollow noreferrer">Raft对比ZAB协议</a></li>
</ul>
<h1>0 一致性问题</h1>
<p>本篇文章想总结下Raft和ZAB在处理一些一致性问题上的做法，详见之前对这2个算法的描述</p>
<ul>
<li><a href="https://my.oschina.net/pingpangkuangmo/blog/776714" rel="external nofollow noreferrer">Raft算法赏析</a></li>
<li><a href="https://my.oschina.net/pingpangkuangmo/blog/778927" rel="external nofollow noreferrer">ZooKeeper的一致性算法赏析</a></li>
</ul>
<p>上述分别是针对如下算法实现的讨论：</p>
<ul>
<li>Raft的实现<a href="https://github.com/atomix/copycat" rel="external nofollow noreferrer">copycat</a>，由于Raft算法本身已经介绍的相当清晰，copycat基本上和Raft算法保持一致</li>
<li>ZAB的实现ZooKeeper，由于ZooKeeper里面的很多实现细节并没有在ZAB里体现（ZAB里面只是一个大概，没有像Raft那么具体），所以这里讨论的都是ZooKeeper的实现</li>
</ul>
<p>一致性算法在实现状态机这种应用时，有哪些常见的问题：</p>
<ul>
<li>1 leader选举</p>
<ul>
<li>1.1 一般的leader选举过程</p>
<p>选举的轮次</p>
<p>选举出来的leader要包含更多的日志</li>
<li>1.2 leader选举的效率
<p>会不会出现split vote？以及各自的特点是？</li>
<li>1.3 加入一个已经完成选举的集群
<p>怎么发现已完成选举的leader？</p>
<p>加入过程是否对leader处理请求的过程造成阻塞？</li>
<li>1.4 leader选举的触发
<p>谁在负责检测需要进入leader选举？</li>
</ul>
</li>
<li>2 上一轮次的leader
<ul>
<li>2.1 上一轮次的leader的残留的数据怎么处理？</li>
<li>2.2 怎么阻止之前的leader假死的问题</li>
</ul>
</li>
<li>3 请求处理流程
<ul>
<li>3.1 请求处理的一般流程</li>
<li>3.2 日志的连续性问题</li>
<li>3.3 如何保证顺序
<ul>
<li>3.3.1 正常同步过程的顺序</li>
<li>3.3.2 异常过程的顺序
<p>follower挂掉又连接</p>
<p>leader更换</li>
</ul>
</li>
<li>3.4 请求处理流程的异常</li>
</ul>
</li>
<li>4 分区的处理</li>
</ul>
<p>下面分别来看看Raft和ZooKeeper怎么来解决的</p>
<h1>1 leader选举</h1>
<p>为什么要进行leader选举？</p>
<p>在实现一致性的方案，可以像base-paxos那样不需要leader选举，这种方案达成一件事情的一致性还好，面对多件事情的一致性就比较复杂了，所以通过选举出一个leader来简化实现的复杂性。</p>
<h2>1.1 一般的leader选举过程</h2>
<p>更多的有2个要素：</p>
<ul>
<li>1.1.1 选举轮次</li>
<li>1.1.2 leader包含更多的日志</li>
</ul>
<p>1.1.1 选举投票可能会多次轮番上演，为了区分，所以需要定义你的投票是属于哪个轮次的。</p>
<ul>
<li>Raft定义了term来表示选举轮次</li>
<li>ZooKeeper定义了electionEpoch来表示</li>
</ul>
<p>他们都需要在某个轮次内达成过半投票来结束选举过程</p>
<p>1.1.2 投票PK的过程，更多的是日志越新越多者获胜</p>
<p>在选举leader的时候，通常都希望</p>
<p><strong>选举出来的leader至少包含之前全部已提交的日志</strong></p>
<p>自然想到包含的日志越新越大那就越好。</p>
<p>通常都是比较最后一个日志记录，如何来定义最后一个日志记录？</p>
<p>有2种选择，一种就是所有日志中的最后一个日志，另一种就是所有已提交中的最后一个日志。目前Raft和ZooKeeper都是采用前一种方式。日志的越新越大表示：轮次新的优先，然后才是同一轮次下日志记录大的优先</p>
<ul>
<li>Raft：term大的优先，然后entry的index大的优先</li>
<li>ZooKeeper：peerEpoch大的优先，然后zxid大的优先
<p>ZooKeeper有2个轮次，一个是选举轮次electionEpoch，另一个是日志的轮次peerEpoch（即表示这个日志是哪个轮次产生的）。而Raft则是只有一个轮次，相当于日志轮次和选举轮次共用了。至于ZooKeeper为什么要把这2个轮次分开，这个稍后再细究，有兴趣的可以一起研究。</li>
</ul>
<p>但是有一个问题就是：通过上述的日志越新越大的比较方式能达到我们的上述希望吗？</p>
<p>特殊情况下是不能的，这个特殊情况详细见上述给出Raft算法赏析的这一部分</p>
<p><a href="https://static.oschina.net/uploads/img/201610/21164723_v2Rh.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjExNjQ3MjNfdjJSaC5wbmc=.jpg"></a></p>
<p>这个案例就是这种比较方式会选举出来的leader可能并不包含已经提交的日志，而Raft的做法则是对于日志的提交多加一个限制条件，即不能直接提交之前term的已过半的entry，即把这一部分的日志限制成未提交的日志，从而来实现上述的希望。</p>
<p>ZooKeeper呢？会不会出现这种情况？又是如何处理的？</p>
<p>ZooKeeper是不会出现这种情况的，因为ZooKeeper在每次leader选举完成之后，都会进行数据之间的同步纠正，所以每一个轮次，大家都日志内容都是统一的</p>
<p>而Raft在leader选举完成之后没有这个同步过程，而是靠之后的AppendEntries RPC请求的一致性检查来实现纠正过程，则就会出现上述案例中隔了几个轮次还不统一的现象</p>
<h2>1.2 leader选举的效率</h2>
<p>Raft中的每个server在某个term轮次内只能投一次票，哪个candidate先请求投票谁就可能先获得投票，这样就可能造成split vote，即各个candidate都没有收到过半的投票，Raft通过candidate设置不同的超时时间，来快速解决这个问题，使得先超时的candidate（在其他人还未超时时）优先请求来获得过半投票</p>
<p>ZooKeeper中的每个server，在某个electionEpoch轮次内，可以投多次票，只要遇到更大的票就更新，然后分发新的投票给所有人。这种情况下不存在split vote现象，同时有利于选出含有更新更多的日志的server，但是选举时间理论上相对Raft要花费的多。</p>
<h2>1.3 加入一个已经完成选举的集群</h2>
<ul>
<li>1.3.1 怎么发现已完成选举的leader？</li>
<li>1.3.2 加入过程是否阻塞整个请求？</li>
</ul>
<p>1.3.1 怎么发现已完成选举的leader？</p>
<p>一个server启动后（该server本来就属于该集群的成员配置之一，所以这里不是新加机器），如何加入一个已经选举完成的集群</p>
<ul>
<li>Raft：比较简单，该server启动后，会收到leader的AppendEntries RPC,这时就会从RPC中获取leader信息，识别到leader，即使该leader是一个老的leader，之后新leader仍然会发送AppendEntries RPC,这时就会接收到新的leader了（因为新leader的term比老leader的term大，所以会更新leader）</li>
<li>ZooKeeper：该server启动后，会向所有的server发送投票通知，这时候就会收到处于LOOKING、FOLLOWING状态的server的投票（这种状态下的投票指向的leader），则该server放弃自己的投票，判断上述投票是否过半，过半则可以确认该投票的内容就是新的leader。</li>
</ul>
<p>1.3.2 加入过程是否阻塞整个请求？</p>
<p>这个其实还要看对日志的设计是否是连续的</p>
<ul>
<li>如果是连续的，则leader中只需要保存每个follower上一次的同步位置，这样在同步的时候就会自动将之前欠缺的数据补上，不会阻塞整个请求过程</p>
<p>目前Raft的日志是依靠index来实现连续的</li>
<li>如果不是连续的，则在确认follower和leader当前数据的差异的时候，是需要获取leader当前数据的读锁，禁止这个期间对数据的修改。差异确定完成之后，释放读锁，允许leader数据被修改，每一个修改记录都要被保存起来，最后一一应用到新加入的follower中。
<p>目前ZooKeeper的日志zxid并不是严格连续的，允许有空洞</li>
</ul>
<h2>1.4 leader选举的触发</h2>
<p>触发一般有如下2个时机</p>
<ul>
<li>server刚开始启动的时候，触发leader选举</li>
<li>leader选举完成之后，检测到超时触发，谁来检测？
<ul>
<li>Raft：目前只是follower在检测。follower有一个选举时间，在该时间内如果未收到leader的心跳信息，则follower转变成candidate，自增term发起新一轮的投票，leader遇到新的term则自动转变成follower的状态</li>
<li>ZooKeeper：leader和follower都有各自的检测超时方式，leader是检测是否过半follower心跳回复了，follower检测leader是否发送心跳了。一旦leader检测失败，则leader进入LOOKING状态，其他follower过一段时间因收不到leader心跳也会进入LOOKING状态，从而出发新的leader选举。一旦follower检测失败了，则该follower进入LOOKING状态，此时leader和其他follower仍然保持良好，则该follower仍然是去学习上述leader的投票，而不是触发新一轮的leader选举</li>
</ul>
</li>
</ul>
<h1>2 上一轮次的leader</h1>
<h2>2.1 上一轮次的leader的残留的数据怎么处理？</h2>
<p>首先看下上一轮次的leader在挂或者失去leader位置之前，会有哪些数据？</p>
<ul>
<li>已过半复制的日志</li>
<li>未过半复制的日志</li>
</ul>
<p>一个日志是否被过半复制，是否被提交，这些信息是由leader才能知晓的，那么下一个leader该如何来判定这些日志呢？</p>
<p>下面分别来看看Raft和ZooKeeper的处理策略：</p>
<ul>
<li>Raft：对于之前term的过半或未过半复制的日志采取的是保守的策略，全部判定为未提交，只有当当前term的日志过半了，才会顺便将之前term的日志进行提交</li>
<li>ZooKeeper：采取激进的策略，对于所有过半还是未过半的日志都判定为提交，都将其应用到状态机中</li>
</ul>
<p>Raft的保守策略更多是因为Raft在leader选举完成之后，没有同步更新过程来保持和leader一致（在可以对外处理请求之前的这一同步过程）。而ZooKeeper是有该过程的</p>
<h2>2.2 怎么阻止上一轮次的leader假死的问题</h2>
<p>这其实就和实现有密切的关系了。</p>
<ul>
<li>Raft的copycat实现为：每个follower开通一个复制数据的RPC接口，谁都可以连接并调用该接口，所以Raft需要来阻止上一轮次的leader的调用。每一轮次都会有对应的轮次号，用来进行区分，Raft的轮次号就是term，一旦旧leader对follower发送请求，follower会发现当前请求term小于自己的term，则直接忽略掉该请求，自然就解决了旧leader的干扰问题</li>
<li>ZooKeeper：一旦server进入leader选举状态则该follower会关闭与leader之间的连接，所以旧leader就无法发送复制数据的请求到新的follower了，也就无法造成干扰了</li>
</ul>
<h1>3 请求处理流程</h1>
<h2>3.1 请求处理的一般流程</h2>
<p>这个过程对比Raft和ZooKeeper基本上是一致的，大致过程都是过半复制</p>
<p>先来看下Raft：</p>
<ul>
<li>client连接follower或者leader，如果连接的是follower则，follower会把client的请求(写请求，读请求则自身就可以直接处理)转发到leader</li>
<li>leader接收到client的请求，将该请求转换成entry，写入到自己的日志中，得到在日志中的index，会将该entry发送给所有的follower(实际上是批量的entries)</li>
<li>follower接收到leader的AppendEntries RPC请求之后，会将leader传过来的批量entries写入到文件中（通常并没有立即刷新到磁盘），然后向leader回复OK</li>
<li>leader收到过半的OK回复之后，就认为可以提交了，然后应用到leader自己的状态机中，leader更新commitIndex，应用完毕后回复客户端</li>
<li>在下一次leader发给follower的心跳中，会将leader的commitIndex传递给follower，follower发现commitIndex更新了则也将commitIndex之前的日志都进行提交和应用到状态机中</li>
</ul>
<p>再来看看ZooKeeper：</p>
<ul>
<li>client连接follower或者leader，如果连接的是follower则，follower会把client的请求(写请求，读请求则自身就可以直接处理)转发到leader</li>
<li>leader接收到client的请求，将该请求转换成一个议案，写入到自己的日志中，会将该议案发送给所有的follower(这里只是单个发送)</li>
<li>follower接收到leader的议案请求之后，会将该议案写入到文件中（通常并没有立即刷新到磁盘），然后向leader回复OK</li>
<li>leader收到过半的OK回复之后，就认为可以提交了，leader会向所有的follower发送一个提交上述议案的请求，同时leader自己也会提交该议案，应用到自己的状态机中，完毕后回复客户端</li>
<li>follower在接收到leader传过来的提交议案请求之后，对该议案进行提交，应用到状态机中</li>
</ul>
<h2>3.2 日志的连续性问题</h2>
<p>在需要保证顺序性的前提下，在利用一致性算法实现状态机的时候，到底是实现连续性日志好呢还是实现非连续性日志好呢？</p>
<ul>
<li>如果是连续性日志，则leader在分发给各个follower的时候，只需要记录每个follower目前已经同步的index即可，如Raft</li>
<li>如果是非连续性日志，如ZooKeeper，则leader需要为每个follower单独保存一个队列，用于存放所有的改动，如ZooKeeper，一旦是队列就引入了一个问题即顺序性问题，即follower在和leader进行同步的时候，需要阻塞leader处理写请求，先将follower和leader之间的差异数据先放入队列，完成之后，解除阻塞，允许leader处理写请求，即允许往该队列中放入新的写请求，从而来保证顺序性</li>
</ul>
<p>还有在复制和提交的时候：</p>
<ul>
<li>连续性日志可以批量进行</li>
<li>非连续性日志则只能一个一个来复制和提交</li>
</ul>
<p>其他有待后续补充</p>
<h2>3.3 如何保证顺序</h2>
<p>具体顺序是什么？</p>
<p>这个就是先到达leader的请求，先被应用到状态机。这就需要看正常运行过程、异常出现过程都是怎么来保证顺序的</p>
<p>3.3.1 正常同步过程的顺序</p>
<ul>
<li>Raft对请求先转换成entry，复制时，也是按照leader中log的顺序复制给follower的，对entry的提交是按index进行顺序提交的，是可以保证顺序的</li>
<li>ZooKeeper在提交议案的时候也是按顺序写入各个follower对应在leader中的队列，然后follower必然是按照顺序来接收到议案的，对于议案的过半提交也都是一个个来进行的</li>
</ul>
<p>3.3.2 异常过程的顺序保证</p>
<p>如follower挂掉又重启的过程：</p>
<ul>
<li>Raft：重启之后，由于leader的AppendEntries RPC调用，识别到leader，leader仍然会按照leader的log进行顺序复制，也不用关心在复制期间新的添加的日志，在下一次同步中自动会同步</li>
<li>ZooKeeper：重启之后，需要和当前leader数据之间进行差异的确定，同时期间又有新的请求到来，所以需要暂时获取leader数据的读锁，禁止此期间的数据更改，先将差异的数据先放入队列，差异确定完毕之后，还需要将leader中已提交的议案和未提交的议案也全部放入队列，即ZooKeeper的如下2个集合数据
<ul>
<li>ConcurrentMap outstandingProposals</p>
<p>Leader拥有的属性，每当提出一个议案，都会将该议案存放至outstandingProposals，一旦议案被过半认同了，就要提交该议案，则从outstandingProposals中删除该议案</li>
<li>ConcurrentLinkedQueue toBeApplied
<p>Leader拥有的属性，每当准备提交一个议案，就会将该议案存放至该列表中，一旦议案应用到ZooKeeper的内存树中了，然后就可以将该议案从toBeApplied中删除</li>
</ul>
<p>然后再释放读锁，允许leader进行处理写数据的请求，该请求自然就添加在了上述队列的后面，从而保证了队列中的数据是有序的，从而保证发给follower的数据是有序的，follower也是一个个进行确认的，所以对于leader的回复也是有序的</li>
</ul>
<p>如果是leader挂了之后，重新选举出leader，会不会有乱序的问题？</p>
<ul>
<li>Raft：Raft对于之前term的entry被过半复制暂不提交，只有当本term的数据提交了才能将之前term的数据一起提交，也是能保证顺序的</li>
<li>ZooKeeper:ZooKeeper每次leader选举之后都会进行数据同步，不会有乱序问题</li>
</ul>
<h2>3.4 请求处理流程的异常</h2>
<p>一旦leader发给follower的数据出现超时等异常</p>
<ul>
<li>Raft：会不断重试，并且接口是幂等的</li>
<li>ZooKeeper：follower会断开与leader之间的连接，重新加入该集群，加入逻辑前面已经说了</li>
</ul>
<h1>4 分区的应对</h1>
<p>目前ZooKeeper和Raft都是过半即可，所以对于分区是容忍的。如5台机器，分区发生后分成2部分，一部分3台，另一部分2台，这2部分之间无法相互通信</p>
<p>其中，含有3台的那部分，仍然可以凑成一个过半，仍然可以对外提供服务，但是它不允许有server再挂了，一旦再挂一台则就全部不可用了。</p>
<p>含有2台的那部分，则无法提供服务，即只要连接的是这2台机器，都无法执行相关请求。</p>
<p>所以ZooKeeper和Raft在一旦分区发生的情况下是是牺牲了高可用来保证一致性，即CAP理论中的CP。但是在没有分区发生的情况下既能保证高可用又能保证一致性，所以更想说的是所谓的CAP二者取其一，并不是说该系统一直保持CA或者CP或者AP，而是一个会变化的过程。在没有分区出现的情况下，既可以保证C又可以保证A，在分区出现的情况下，那就需要从C和A中选择一样。ZooKeeper和Raft则都是选择了C。</p>
<p>欢迎关注微信公众号：乒乓狂魔</p>
<p><a href="https://static.oschina.net/uploads/img/201610/28090041_LsUp.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjgwOTAwNDFfTHNVcC5wbmc=.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-21 23:22:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/zookeeper/" title="zookeeper">zookeeper</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e8%87%b4%e6%80%a7/" title="一致性">一致性</a>, <a href="https://www.iamivan.net/tag/zab/" title="zab">zab</a>, <a href="https://www.iamivan.net/tag/raft/" title="raft">raft</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Raft对比ZAB协议的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAQaOJM.html" rel="bookmark">ZAB协议</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				zookeeper依赖zab协议来实现分布式数据一致性.基于该协议,zookeeper实现了一种主备模式的系统架构来保持ZooKeeper为高可用的一致性协调框架,自然的ZooKeeper也有着一致性算法的实现,ZooKeeper使用的是ZAB协议作为数据一致性的算法, ZAB(ZooKeeper Atomic Broadcast ) 全称为:原子消息广播协议:ZAB可以说是在Paxos算法基础上进行了扩展改造而来的,ZAB协议设计了支持崩溃恢复,ZooKeeper使用单一主进程Leader用于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqR4yap.html" rel="bookmark">Zookeeper ZAB 协议分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 ZAB 协议是为分布式协调服务 ZooKeeper 专门设计的一种支持崩溃恢复的原子广播协议.在 ZooKeeper 中,主要依赖 ZAB 协议来实现分布式数据一致性,基于该协议,ZooKeeper 实现了一种主备模式的系统架构来保持集群中各个副本之间的数据一致性. Atomic broadcast protocol ZAB 是 Zookeeper 原子广播协议的简称,下面我们来讨论协议的内容,注意:理论与实现是有区别的,如果你对协议的理论不感兴趣,可以直接跳过看实现. 问题的提出 Zoo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ2A1qz.html" rel="bookmark">ZAB协议恢复模式-leader选举</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前在网上看了很多zookeeper的zab原理,但讲述的都不够详细,很多地方模糊不清,所以就研究了一下zookeeper源码,并整理成几篇博客,希望对其他小伙伴有所帮助.本文是ZAB协议崩溃恢复Leader选举部分的内容,数据同步见另一篇博客 &lt;ZAB协议恢复模式-数据同步&gt;    . 为了避免理解上的歧义,将投票动作和投票信息区分开,在本文中,我将服务器的投票信息称之为选票. 一  基本概念 1.  Noitifcation Notification其实是选举过程中的通信信息:选举过程主要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2622ob.html" rel="bookmark">ZAB协议恢复模式-数据同步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博客中,我们详细讨论了Zookeeper的Leader选举过程,接下来我们讨论一下Leader选举以后的事情,并了解zookeeper的集群管理原理. 提前说明: 本文主题虽然是讲述崩溃恢复模式,不过也会对广播模式的内容进行简单的描述. 为了在文中描述不至于太过啰嗦,所以对超过半数省略掉了一个限定返回.例如当出现类似于&quot;超过半数follower与leader同步&quot;,&quot;收到超过半数follower的回复&quot;这种描述时,这种描述不正确,因为这个半数计算的时候是包含l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkEoVb.html" rel="bookmark">Raft算法赏析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 leader选举 1.1 刚开始所有server启动都是follower状态 然后等待leader或者candidate的RPC请求.或者超时. 上述3种情况处理如下: leader的AppendEntries RPC请求:更新term和leader信息,当前follower再重新重置到follower状态 candidate的RequestVote RPC请求:为candidate进行投票,如果candidate的term比自己的大,则当前follower再重新重置到follower状态			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YgQRM.html" rel="bookmark">ZooKeeper的一致性算法赏析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 ZAB介绍 ZAB协议全称就是ZooKeeper Atomic Broadcast protocol,是ZooKeeper用来实现一致性的算法,分成如下4个阶段. 先来解释下部分名词 electionEpoch:每执行一次leader选举,electionEpoch就会自增,用来标记leader选举的轮次 peerEpoch:每次leader选举完成之后,都会选举出一个新的peerEpoch,用来标记事务请求所属的轮次 zxid:事务请求的唯一标记,由leader服务器负责进行分配.由2部分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boK9Lgb.html" rel="bookmark">DockOne微信分享（一零四）：艺龙部署体系的演进</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是DockOne微信分享(一零四):艺龙部署体系的演进[编者的话]随着公司业务规模的逐渐扩大,传统的基于机器层面的部署系统在面对服务扩缩容.故障迁移.成本控制等方面已经越来越力不从心,于是,我们开始将容器技术与当前公司内部已有的自动化运维体系相结合,来实现一套艺龙的容器云平台,以期解决上述问题. 原有部署平台的架构设计 在讲解部署系统之前,我先给大家讲一下目前艺龙自动化运维的业务模型.早期艺龙的运维,因为规模较小,通常人工处理,当规模大了以后,就开始尝试基于Puppet等脚本的方式操作.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3j3Vp.html" rel="bookmark">《HBase权威指南》一1&period;4　结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 结构 本节首先介绍HBase的架构,然后介绍一些关于HBase起源的背景资料,之后将介绍其数据模型的一般概念和可用的存储API,最后在一个更高的层次上对其实现细节进行分析. 1.4.1 背景 2003年,Google发表了一篇论文,叫&quot;The Google File System&quot;(http://labs.google.com/papers/gfs.html).这个分布式文件系统简称GFS,它使用商用硬件集群存储海量数据.文件系统将数据在节点之间冗余复制,这样的话,即使一台存储			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmjnLz.html" rel="bookmark">当讨论分布式系统时，我们都会讨论些什么？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是当讨论分布式系统时,我们都会讨论些什么,[编者的话]分布式系统是一个庞大的议题,每个子领域都有大量的研究.学习分布式系统知识,如果不分主次地随看随学,效果不会好.本文介绍了分布式系统的主要概念,适合作为分布式系统的入门指南. 当我们讨论分布式系统时,我们都讨论些什么? 我一直在学习有关分布式系统的知识,学习时间不算短了.老实说,只要你开始钻研分布式系统,知识点好像学不完似的,一个接一个.分布式系统领域的文献太多了,包括许多大学发表的论文,还有很多书籍可选.像我这样的绝对新手,很难决定应			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0RR6z.html" rel="bookmark" class="title">2345浏览器怎么拦截广告</a>
					<div>
						  现在,很多用户在使用2345浏览器.不过有些用户在反映2345浏览器要怎么拦截广告.其实,2345浏览器的广告智能拦截功能一直为人们所称道,尤其是对侵入式视频前贴片广告的拦截更是达到了百发百中的能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKL17M.html" rel="bookmark" class="title">QQ影音感念亲恩皮肤，不只是大按钮这么简单</a>
					<div>
						QQ影音感念亲恩皮肤,不只是大按钮这么简单					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM931Rz.html" rel="bookmark" class="title">HCC：新站怎么让百度收录及持续收录</a>
					<div>
						  如何让网站被百度更快录,首先,你的网站是否挂上去了呢?当然,应该还没有菜了如此地步的站长及站长爱好者吧.HCC一直都认为这个网络蜘蛛很人性化,也是需要付出感情去勾引蜘蛛来读取你的网站数据.因此,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvXm9z.html" rel="bookmark" class="title">提高网站关键词排名必要的10个技巧</a>
					<div>
						如何做好自己网站关键词的排名,是每个seoer都非常关系的问题,今天跟大家交流下我这几年来对优化的接触和经历,跟大家分享下其中的技巧和注意事项!对提高你网站排名绝对有好处! 一:网站关键词的处理:包括 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjOlmM.html" rel="bookmark" class="title">redhat中设置SSH基于密钥的用户登陆</a>
					<div>
						在SSH客户机中建立名为gates的用户,并以gates的身份在其宿主目录中的.ssh隐藏目录中生成用户的密钥对文件 2.利用scp将该目录下的公钥文件id_rsa.pub文件复制到你要登陆的开启SS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKgOEM.html" rel="bookmark" class="title">photoshop怎么利用滤镜制作抽象的火焰光束效果</a>
					<div>
						 photoshop怎么利用滤镜制作抽象的火焰光束 1.创建一个新文档.我设定它大小为800×600.选择油漆桶工具(G)用黑色填充背景,而后拷贝一层图层(Cmd+J). 2.去[滤镜&gt;渲染&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Wxanb.html" rel="bookmark" class="title">Win7如何恢复好压右键菜单</a>
					<div>
						  方法一:好压的自动修复功能 1.右击想要压缩或者解压的文件,查看是否有好压的解压缩选项.正常情况应该是这样的,会出现好压的解压缩选项. 2.如果右键出现下图的情况就是好压的右键菜单消失了,可以尝试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYnk6b.html" rel="bookmark" class="title">咪咕音乐播放器如何卸装</a>
					<div>
						  咪咕音乐播放器可以通过Windows的&quot;开始&quot;菜单→&quot;所有程序&quot;→&quot;咪咕音乐&quot;→&quot;卸载咪咕音乐&quot;来卸载咪咕音乐播放器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNaKZM.html" rel="bookmark" class="title">Excel2000如何编辑与查询数据记录</a>
					<div>
						  Excel2000如何编辑与查询数据记录: 对于数据清单中的数据记录,中文Excel 2000允许您做与Visual FoxPro 6中相同的编辑操作,即可新建.删除数据记录.按某些条件查询数据记 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Ko4b.html" rel="bookmark" class="title">巧克力键盘的特点什么</a>
					<div>
						什么是巧克力键盘?这里小编也是搜集了一些相关信息来给代价解释一下巧克力键盘结构及优点. 2012年最受关注的IT新品非&quot;超级本&quot;莫属,随着超级本逐渐变得主流,很多消费者目前均从传统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwkNDb.html" rel="bookmark" class="title">笔记本电脑键盘失灵怎么办</a>
					<div>
						笔记本电脑的键盘是最容易出现问题的部件,笔记本电脑键盘失灵对于用户来说可是天降灾难.本来用的好好的本本,突然之间因为某些原因,键盘发生意外,就出现键盘失灵无法响应,导致正在进行的工作游戏无法再进行下去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGx7Db.html" rel="bookmark" class="title">设置快捷键通过Twitter或信息应用共享Safari网页</a>
					<div>
						  我们知道在Mountain Lion Safari中有一个共享按键,允许用户利用Twitter或信息应用来共享网页,但是它没有默认的键盘快捷.下面我们就教你如何给这个操作设置快捷键. -打开系统偏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad3yNz.html" rel="bookmark" class="title">查看服务器的BIOS是否开启CPU虚拟化</a>
					<div>
						有关CPU是否支持虚拟化,我们可以通过相关的命令和软件进行查看. 在windows系统下,我们可以使用CPU-Z这个软件,如下图: 在linux系统下,我们可以通过查看/proc/cpuinfo文件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNEg8M.html" rel="bookmark" class="title">React 组件间通讯</a>
					<div>
						React 组件间通讯 说 React 组件间通讯之前,我们先来讨论一下 React 组件究竟有多少种层级间的关系.假设我们开发的项目是一个纯 React 的项目,那我们项目应该有如下类似的关系: 父 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5onrWb.html" rel="bookmark" class="title">学习nodejs部分基础内容入门小结</a>
					<div>
						Node.js 是一个基于 Chrome V8 引擎的 JavaScript 运行环境. Node.js 使用了一个事件驱动.非阻塞式 I/O 的模型,使其轻量又高效. Node.js 的包管理器 n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAK4nM.html" rel="bookmark" class="title">央视曝光星牛电器等违规生产老国标插线板</a>
					<div>
						[演播室]共同打造高质量的生活,欢迎收看&lt;每周质量报告&gt;.插线板应该算是我们的生活必需品,可能插线板不太起眼,平时可能也很少会引起大家的关注,但 是就是这不起眼的插线板,如果不达标不合格, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQYERp.html" rel="bookmark" class="title">两种配置大数据环境的方法Ambari以及hadoop源代码安装的步骤</a>
					<div>
						1.Ambari安装 Ambari &amp; HDP(Hortonworks Data Platform) ********************************************* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwrQop.html" rel="bookmark" class="title">抽象类注入JedisPool失败</a>
					<div>
						问题描述 抽象类注入JedisPool失败 public abstract class BusinessIdGenerateAbstract implements Serializable{ prot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgEvab.html" rel="bookmark" class="title">Java中vector理解1&mdash;&mdash;vector的用法</a>
					<div>
						Vector可实现自动增长的对象数组. java.util.vector提供了向量类(vector)以实现类似动态数组的功能.在Java语言中没有指针的概念,但如果正确灵活地使用指针又确实可以大大提高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Z81ap.html" rel="bookmark" class="title">systemparametersinfo-vs2012 c&num; SystemParametersInfo 在win7下无法设置桌面背景</a>
					<div>
						问题描述 vs2012 c# SystemParametersInfo 在win7下无法设置桌面背景 程序在win10下可用.在win7下一直返回值:0 using System; using Sys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRd6Vb.html" rel="bookmark" class="title">代码混淆-android studio 混淆文件配置</a>
					<div>
						问题描述 android studio 混淆文件配置 下面是我的配置文件: -optimizationpasses 5 -dontusemixedcaseclassnames -verbose -do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeGQrb.html" rel="bookmark" class="title">电子商务的十条潜规则</a>
					<div>
						做电子商务也有好几年了,从C店到B店再到独网,成就虽然不大,但是也赚了不少的钱,目标还是清晰并坚定,今天就抛砖引玉一下,说几条话糙理不糙的电商潜规则吧. 1. 做得不如C,千万不要装B.这句话很实在, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7rZJp.html" rel="bookmark" class="title">HDFS文件系统和对象存储有何不同？</a>
					<div>
						最近在Quora上有人提到一个问题,有关Hadoop分布式文件系统和OpenStack对象存储的不同. 问题原文如下: &quot;HDFS (Hadoop分布式文件系统)和OpenStack对象存储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0wxlp.html" rel="bookmark" class="title">小白求教-消息框？？？？？？？？</a>
					<div>
						问题描述 消息框???????? Windows.Forms.MessageBoxButtons.OKCancel 和 MessageBoxButtons.OKCancel 的区别 解决方案 一样的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RYxnz.html" rel="bookmark" class="title">轻松提高网站在搜索引擎中的权重</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 众所周知,在搜索引擎优化中网站的权 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXmAZb.html" rel="bookmark" class="title">我记和asp&period;net webforms中可以用mypage&period;aspx和mypage&period;mobile&period;aspx，用户浏览时，可根据浏览器，自动呈现页面的</a>
					<div>
						问题描述 我记和asp.netwebforms(不是MVC)中,可以用mypage.aspx和mypage.mobile.aspx,用户浏览时,可根据浏览器是否是手机还是PC,自动呈现页面的,同时在地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqZZOb.html" rel="bookmark" class="title">超模坎蒂丝-斯瓦内普尔全裸拍摄宣传照</a>
					<div>
						模坎蒂丝-斯瓦内普尔日前为美国时装设计师协会大奖拍摄了一组全裸宣传照. 超模坎蒂丝-斯瓦内普尔全裸拍摄宣传照[page][page] [page] 超模坎蒂丝-斯瓦内普尔全裸拍摄宣传照 超模坎蒂丝-斯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKW0Wz.html" rel="bookmark" class="title">windows xp电脑怎么连接wifi&quest;</a>
					<div>
						windows xp设置wifi教程: 1.打开网络连接(可以在开始里面找,也可以进网络邻居里点连接),点&quot;本地连接&quot;(或者说你联了网的连接),右键属性,进高级选项卡,intern ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm40ap.html" rel="bookmark" class="title">CSS&plus;js Cookie实现的固定页脚广告条例子</a>
					<div>
						经常看到有些网站为了吸引用户注意,在页面底部放置固定横幅广告,用户滚动页面时,横幅广告一直固定在页底,并不随页面滚动而滚动,当然一般允许用户可以关闭广告条,并设置一定时间内不再显示此广告条.本文将介绍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NkLgp.html" rel="bookmark" class="title">网易年终&OpenCurlyDoubleQuote;大输血&rdquo;意欲何为？</a>
					<div>
						年末,各大门户网站又在执行一年一度的&quot;大换血&quot;行动,网易作为国内的三大门户之一,其一举一动是备受关注的. 这个月中旬就想写这篇文章的,但由于时间不是很充裕,才一直拖到今天.这次网易 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
